双向广搜 POJ 3126 Prime Path

 

POJ 3126  Prime Path

Time Limit: 1000MS   Memory Limit: 65536K
Total Submissions: 16204   Accepted: 9153

Description

双向广搜  POJ 3126  Prime PathThe ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.

1033
1733
3733
3739
3779
8779
8179

The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0

大致题意:

给定两个四位素数a  b,要求把a变换到b

变换的过程要保证  每次变换出来的数都是一个 四位素数,而且当前这步的变换所得的素数  与  前一步得到的素数  只能有一个位不同,而且每步得到的素数都不能重复。

求从a到b最少需要的变换次数。无法变换则输出Impossible

注意:双向广搜是在一个队列中实现的,只不过是交替进行罢了!

 #include<iostream>
using namespace std;
#include<cstdio>
#include<cstring>
#include<cmath>
#include<cstdlib>
#include<queue>
#define N 10000
struct prime{
int c[];
int flag;
};
int dis[N];
int visit[N];
queue<prime>que;
int js(int *m)
{
return (m[]*+m[]*+m[]*+m[]*);
}
bool is_prime(int l)
{
bool flag=true;
for(int i=;i<=sqrt(l);++i)
{
if(l%i==)
{
flag=false;
break;
}
}
return flag;
}
int bfs()
{
while(!que.empty())
{
prime x=que.front();
que.pop();
int now=js(x.c);
for(int i=;i<=;++i)
{
prime nx=x;
nx.c[]=i;
int shu=js(nx.c);
if(!visit[shu]&&is_prime(shu))
{
visit[shu]=x.flag;
nx.flag=x.flag;
que.push(nx);
dis[shu]=dis[now]+;
}
else if(visit[shu]&&visit[shu]!=x.flag)
{
return dis[now]+dis[shu]+;
}
}
for(int j=;j<=;++j)
{
for(int i=;i<=;++i)
{
prime nx=x;
nx.c[j]=i;
int shu=js(nx.c);
if(!visit[shu]&&is_prime(shu))
{
visit[shu]=x.flag;
nx.flag=x.flag;
que.push(nx);
dis[shu]=dis[now]+;
}
else if(visit[shu]&&visit[shu]!=x.flag)
{
return dis[now]+dis[shu]+;
}
} }
}
return -;
}
int main()
{
int tex;
scanf("%d",&tex);
char a[];
while(tex--)
{
while(!que.empty()) que.pop();
memset(dis,,sizeof(dis));
memset(visit,,sizeof(visit));
scanf("%s",a);
que.push(prime{a[]-'',a[]-'',a[]-'',a[]-'',});
int p=(a[]-'')*+(a[]-'')*+(a[]-'')*+(a[]-'');
visit[p]=;dis[p]=;
int q=p;
scanf("%s",a);
que.push(prime{a[]-'',a[]-'',a[]-'',a[]-'',});
p=(a[]-'')*+(a[]-'')*+(a[]-'')*+(a[]-'');
visit[p]=;dis[p]=;
if(q==p)
{
printf("0\n");continue;
}
int temp=bfs();
if(temp==-) printf("Impossible\n");
else printf("%d\n",temp);
}
return ;
}
上一篇:论JavaWeb前后端分离放弃jsp


下一篇:代码记录——phase16,block32